Hexagram h1;
Hexagram h2;
Hexagram h3;
Hexagram h4;
Hexagram h5;
Hexagram h6;


void setup () {
  size (600, 360);

  h1 =new Hexagram (40, 30, 10, true, false, true, true, false, false);
  h2 =new Hexagram (220, 30, 10, false, false, false, true, false, true);
  h3 =new Hexagram (400, 30, 10, true, false, true, false, false, true);
  h4 =new Hexagram (40, 180, 10, false, false, true, true, false, false);
  h5 =new Hexagram (220, 180, 10, true, false, false, true, true, true);
  h6 =new Hexagram (400, 180, 10, true, true, true, true, false, false);
  
}


void draw () {
  background (255);
  h1.display();
  h2.display();
  h3.display();
  h4.display();
  h5.display();
  h6.display();
}


class Hexagram {

  //pivot point is the top left corner of the whole hexagram
  float pivotX;
  float pivotY;
  float lineWeight;
  
  //broken or unbroken values stored for each line in the constructor
  boolean l1;
  boolean l2;
  boolean l3;
  boolean l4;
  boolean l5;
  boolean l6;

  Hexagram (float temppivotX, float temppivotY, float templineWeight, boolean tempL1, boolean tempL2, boolean tempL3, boolean tempL4, boolean tempL5, boolean tempL6) {
    pivotX = temppivotX;
    pivotY = temppivotY;
    lineWeight = templineWeight;
    
    l1 = tempL1;
    l2 = tempL2;
    l3 = tempL3;
    l4 = tempL4;
    l5 = tempL5;
    l6 = tempL6;
  }

  void display () {
    float spacing = lineWeight*2;
    float lineLength = (lineWeight*6) + (spacing*4);

    strokeCap (SQUARE);
    stroke (0);
    strokeWeight (lineWeight);

    myline(pivotX, pivotY+spacing, lineLength, l1);
    myline(pivotX, pivotY+2*spacing, lineLength, l2);
    myline(pivotX, pivotY+3*spacing, lineLength, l3);
    myline(pivotX, pivotY+4*spacing, lineLength, l4);
    myline(pivotX, pivotY+5*spacing, lineLength, l5);
    myline(pivotX, pivotY+6*spacing, lineLength, l6);
    
   
  }
}



//myline is a function for drawing a single line -- we want to pass this into the object

void myline (float lineStartX, float lineStartY, float len, boolean broken) {

  //line styling
  if (!broken) {
    line (lineStartX, lineStartY, lineStartX+len, lineStartY);
  } 
  else {
    //first line
    line (lineStartX, lineStartY, lineStartX+len/2 - 10, lineStartY);

    //second line
    //how do i pass a variable from the object into this function? always want the two lines to be separated by the line weight, which gets declared and initialized in the object
    line (lineStartX+len/2 +10, lineStartY, lineStartX+len, lineStartY);
  }
}
